var midi = null;
var output = null;
var port = 0;

var header = [240, 65, 16, 66, 18];
var footer = 247;

var efxMSB;
var efxLSB;

var log = false;

var efx1 = 64;
var efx2 = 64;
var efx3 = 64;
var efx4 = 64;

var efxParam1;
var efxParam2;
var efxParam3;
var efxParam4;
var efxParam5;
var efxParam6;
var efxParam7;
var efxParam8;
var efxParam9;
var efxParam10;
var efxParam11;
var efxParam12;
var efxParam13;
var efxParam14;
var efxParam15;
var efxParam16;
var efxParam17;
var efxParam18;
var efxParam19;
var efxParam20;

channel = 1;

function MIDIconnect()
{
    navigator.requestMIDIAccess({
        sysex: true
    }).then(onMIDISuccess, onMIDIFailure);
}


function onMIDISuccess(midiAccess)
{
   

    for (var entry of midiAccess.outputs)
    {        
        var label = entry[1].name;
        var value = entry[0];
        var html = '<a class="dropdown-item midiPort" data-value="' + value + '" href="#">' + label + '</a>';
        $("#PortDropdown").append(html);
        if (label == "Roland Digital Piano") {
            port = value;
            $("#PortLabel").html(label)
        }
        else $("#PortLabel").html("Please select a MIDI port");
    }

    midi = midiAccess;
    output = midiAccess.outputs.get(port);
    parseMIDIInput(midiAccess);
}


function onMIDIFailure(msg)
{
 console.log("MIDI Failure.") 
}


function parseMIDIInput(midiAccess)
{
    midiAccess.inputs.forEach(function (entry)
    {
        entry.onmidimessage = onMIDIMessage;
    });
}

function onMIDIMessage(event)
{
   output.send(event.data);
}



function sysex(data)
{
    data = appendChecksum(data);
    

    var sysexData = header.concat(data, footer);
    if (log) console.log(sysexData);
    try{
        output.send(sysexData);
       
    } catch (e)
    {
        if(log) console.log("Failed to send Sysex data")
    }
    
}
