$(document).ready(function () {

    MIDIconnect();

    $(".patchSelect").click(function () {
        $('.patchSelect.selected').removeClass("selected");
        $(this).addClass("selected");

        var msb = parseInt($(this).data("msb"));
        var lsb = parseInt($(this).data("lsb"));
        var pc = parseInt($(this).data("pc")) - 1;

        var bankSelect = 0xB0 + (channel - 1);
        var patchSelect = 0xC0 + (channel - 1);

        output.send([bankSelect, 0, msb]);
        output.send([bankSelect, 32, lsb]);
        output.send([patchSelect, pc]);

    });

    $(".midiChannel").click(function () {
        var v = $(this).data("value");
        channel = v;
        $("#ChannelLabel").html(v);

    });

    $(document).on('click', '.midiPort', function () {
        var v = $(this).data("value");
        port = (v);
        output = midi.outputs.get(port);
        $("#PortLabel").html($(this).html());
    })

    $("#switch").click(function () {
        var patch = parseInt($("#patch").val()) - 1;
        var bank = parseInt($("#bank").val());

        var bankSelect = 0xB0 + (channel - 1);
        var patchSelect = 0xC0 + (channel - 1);

       

        output.send([bankSelect, 0, 121]);
        output.send([bankSelect, 32, bank]);
        output.send([patchSelect, patch]);


    });

    $(".efxSelect").click(function () {
        $('.efxSelect.selected').removeClass("selected");
        $(this).addClass("selected");

        efxMSB = parseInt($(this).data("msb"));
        efxLSB = parseInt($(this).data("lsb"));

        //console.log(efxMSB + " " + efxLSB);


        //SYSTEM EFX TYPE
        sysex([
            0x40, 0x03, 0x00,
	        efxMSB, efxLSB
        ]);

        //PART EFX TYPE
        sysex([
            0x40, 0x41, 0x23,
	        efxMSB, efxLSB,
            efx1, efx2, efx3, efx4
        ]);

    });

    $("#efxMacro").knob({
        change: function (value) {
            value = parseInt(value);
            if (value != efx1) {
                efx1 = value;
                partEfx();
            }
        }
    });

    $("#efxDepth").knob({
        change: function (value) {
            value = parseInt(value);
            if (value != efx2) {
                efx2 = value;
                partEfx();
            }
        }
    });

    $("#efxControl1").knob({
        change: function (value) {
            value = parseInt(value);
            if (value != efx3) {
                efx3 = value;
                partEfx();
            }
        }
    });

    $("#efxControl2").knob({
        change: function (value) {
            value = parseInt(value);
            if (value != efx4) {
                efx4 = value;
                partEfx();
            }
        }
    });

    function partEfx() {
        //PART EFX TYPE
        sysex([
            0x40, 0x41, 0x23,
	        efxMSB, efxLSB,
            efx1, efx2, efx3, efx4
        ]);
    }


    $("#efxParam1").knob({
        change: function (value, data) {
            var nr = 1;
            value = parseInt(value);
            if (value != efxParam1) {
                efxParam1 = value;
                sysex([0x40, nr + 2, 0x04, value]);
            }
        }
    });
    $("#efxParam2").knob({
        change: function (value, data) {
            var nr = 2;
            value = parseInt(value);
            if (value != efxParam2) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam3").knob({
        change: function (value, data) {
            var nr = 3;
            value = parseInt(value);
            if (value != efxParam3) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam4").knob({
        change: function (value, data) {
            var nr = 4;
            value = parseInt(value);
            if (value != efxParam4) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam5").knob({
        change: function (value, data) {
            var nr = 5;
            value = parseInt(value);
            if (value != efxParam5) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam6").knob({
        change: function (value, data) {
            var nr = 6;
            value = parseInt(value);
            if (value != efxParam6) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam7").knob({
        change: function (value, data) {
            var nr = 7;
            value = parseInt(value);
            if (value != efxParam7) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam8").knob({
        change: function (value, data) {
            var nr = 8;
            value = parseInt(value);
            if (value != efxParam8) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam9").knob({
        change: function (value, data) {
            var nr = 9;
            value = parseInt(value);
            if (value != efxParam9) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam10").knob({
        change: function (value, data) {
            var nr = 10;
            value = parseInt(value);
            if (value != efxParam10) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam11").knob({
        change: function (value, data) {
            var nr = 11;
            value = parseInt(value);
            if (value != efxParam11) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam12").knob({
        change: function (value, data) {
            var nr = 12;
            value = parseInt(value);
            if (value != efxParam12) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam13").knob({
        change: function (value, data) {
            var nr = 13;
            value = parseInt(value);
            if (value != efxParam13) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam14").knob({
        change: function (value, data) {
            var nr = 14;
            value = parseInt(value);
            if (value != efxParam14) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam15").knob({
        change: function (value, data) {
            var nr = 15;
            value = parseInt(value);
            if (value != efxParam15) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam16").knob({
        change: function (value, data) {
            var nr = 16;
            value = parseInt(value);
            if (value != efxParam16) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam17").knob({
        change: function (value, data) {
            var nr = 17;
            value = parseInt(value);
            if (value != efxParam17) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam18").knob({
        change: function (value, data) {
            var nr = 18;
            value = parseInt(value);
            if (value != efxParam18) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam19").knob({
        change: function (value, data) {
            var nr = 19;
            value = parseInt(value);
            if (value != efxParam19) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });
    $("#efxParam20").knob({
        change: function (value, data) {
            var nr = 20;
            value = parseInt(value);
            if (value != efxParam20) {
                efxParam1 = value;
                sysex([0x40, 0x03, nr + 2, value]);
            }
        }
    });

    $("#setSysexHeader").click(function ()
    {
        

        header[0] = parseInt($("#sysexHeader1").val());
        header[1] = parseInt($("#sysexHeader2").val());
        header[2] = parseInt($("#sysexHeader3").val());
        header[3] = parseInt($("#sysexHeader4").val());
        header[4] = parseInt($("#sysexHeader5").val());
        console.log(header);
    });

    $("#logToggle").click(function ()
    {
        log = $(this).prop('checked');
    });

});