



var midi = null;  // global MIDIAccess object

function onMIDISuccess( midiAccess ) {
  console.log( "MIDI ready!" );
  midi = midiAccess;  // store in the global (in real usage, would probably keep in an object instance)
  
  listInputsAndOutputs(midi);
  
  startLoggingMIDIInput(midi, 2);

  sendSysEx(midi, 2);

  controller(midi, 2);
  patchChange(midi, 2);
 // sendMiddleC(midi, 2);
  
}

function onMIDIFailure(msg) {
  console.log( "Failed to get MIDI access - " + msg );
}

navigator.requestMIDIAccess( 
{ 
sysex: true 
} ).then( onMIDISuccess, onMIDIFailure );

function listInputsAndOutputs( midiAccess ) {
  for (var entry of midiAccess.inputs) {

      console.log(entry);
  }

  for (var entry of midiAccess.outputs) {


    console.log(entry);

  }
}


function onMIDIMessage( event ) {

  //console.log( event );
  
    sendNote(midi, 2, event.data);
}

function sendNote( midiAccess, portID, data)
{
	var output = midiAccess.outputs.get(portID);
	output.send( data ); 
}

function startLoggingMIDIInput( midiAccess, indexOfPort ) {
  midiAccess.inputs.forEach( function(entry) {entry.onmidimessage = onMIDIMessage;});
}

function patchChange( midiAccess, portID)
{
	var message = [0xC0,81];
	var output = midiAccess.outputs.get(portID);
	output.send( message );
	
}

function controller( midiAccess, portID)
{

    var message = [0xB0, 91, 127];
	var output = midiAccess.outputs.get(portID);
	output.send( message );
	
}

function sendSysEx(midiAccess, portID) {

    var output = midiAccess.outputs.get(portID);

  //  var message = makeSysex(64, 1, 48, 7); // reverb 1 - 7
   
    var message = makeSysex([64, 3, 0, 1, 6, 54]);


    console.log(message);
    output.send(message);

    var message2 = makeSysex([64, 3, 3, 2, 56]);




    console.log(message2);
    output.send(message2);

    var message3 = makeSysex([64, 3, 5, 50, 6]);
    console.log(message3);
    output.send(message3);
    

}

function makeSysex(data)
{
    var header = [240, 65, 16, 66, 18];

//    var checksum = 128 - (a+b+c+d);
    var footer = 247;

    var message = header.concat(data, footer);
    return message;
}


	
function sendMiddleC( midiAccess, portID ) {
  var noteOnMessage = [0x90, 42, 0x42];    // note on, middle C, full velocity
  var output = midiAccess.outputs.get(portID);
  output.send( noteOnMessage );  //omitting the timestamp means send immediately.
  output.send( [0x80, 42, 0x40], window.performance.now() + 1000.0 ); // Inlined array creation- note off, middle C,  
                                                                      // release velocity = 64, timestamp = now + 1000ms.
}